--- u-boot-2011.06_original/common/cmd_cslogo.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_cslogo.c	2016-03-02 15:58:51.137133000 +0800
@@ -0,0 +1,488 @@
+/****************************************************************************
+ * Copyright (C) 2011 Cavium Inc.
+ * All rights reserved
+ *
+ * [RELEASE HISTORY]
+ * VERSION  DATE       AUTHOR                  DESCRIPTION
+ * 0.1      11-10-11       Jia Ma           		Original
+ ****************************************************************************
+ */
+
+#include <common.h>
+#include <command.h>
+#include <asm/byteorder.h>
+#include <malloc.h>
+#include "cnc_util.h"
+#include "../drivers/cnc1900/df/df.h"
+#include "../drivers/cnc1900/cncedid/cnc_edid.h"
+
+/*#define SPLASH_BUFFER 					0x01000000
+#define TEMP_SPLASH_BUFFER 				0x02000000
+*/
+#define SPLASH_BUFFER                                   0x0f000000
+#define TEMP_SPLASH_BUFFER                              0x0f800000
+#define MAX_TEMP_SPLASH_BUFFER_SIZE		(8*1024*1024)
+
+unsigned int screen_w,screen_h,picture_color_mode,pixel_width,GFXLINEPITCHSIZE;
+
+
+/*COLOR_FORMAT_RGB565    = 2
+  COLOR_FORMAT_ARGB4444  = 3
+  COLOR_FORMAT_ARGB1555  = 5
+  COLOR_FORMAT_ARGB8888  = 6*/
+/*
+   PixelOutputFormat=TVOUT_MODE
+   PictureColorMode=DF_GFX_COLOR_FORMAT
+   */
+static void DISP_SET_FLAG(unsigned int flag)
+{
+	unsigned int *ctl_cfg;
+	ctl_cfg = (unsigned int *)0xfff0000;
+	*ctl_cfg=flag;
+}
+
+extern int disp_init(TVOUT_MODE mode, int pic_w, int pic_h, int dst_x, int dst_y,unsigned char * pData,int hdcp_status, int colorspace_mode);
+static int DrawPicture(unsigned int aImageWidth, unsigned int aImageHeight, unsigned int aOffsetTop, unsigned int aOffsetLeft,
+		unsigned int PixelOutputFormat ,
+		unsigned int PictureColorMode , unsigned char* apData,int hdcp_status, int colorspace_mode
+		)
+{
+#if 1
+	picture_color_mode =PictureColorMode;
+
+	switch(PixelOutputFormat){
+		case 0:
+		case 2:
+		case 8:
+		case 10:
+		case 11:
+			screen_w = 720;
+			screen_h = 576;
+			GFXLINEPITCHSIZE = 720*2;
+			break;
+		case 1:
+		case 3:
+		case 9:
+			screen_w = 720;
+			screen_h = 480;
+			GFXLINEPITCHSIZE = 720*2;
+			break;
+		case 4:
+		case 5:
+		case 20:
+			screen_w = 1280;
+			screen_h = 720;
+			GFXLINEPITCHSIZE = 1280*2;
+			break;
+		case 6:
+		case 7:
+		case 12:
+		case 13:
+		case 14:
+		case 15:
+		case 16:
+			screen_w = 1920;
+			screen_h = 1080;
+			GFXLINEPITCHSIZE = 1920*2;
+			break;
+		case 17:
+			screen_w = 640;
+			screen_h = 480;
+			GFXLINEPITCHSIZE = 640*2;
+			break;
+		case 18:
+			screen_w = 800;
+			screen_h = 600;
+			GFXLINEPITCHSIZE = 800*2;
+			break;
+		case 19:
+			screen_w = 1024;
+			screen_h = 768;
+			GFXLINEPITCHSIZE = 1024*2;
+			break;
+		case 53:
+			screen_w = 1366;
+			screen_h = 768;
+			GFXLINEPITCHSIZE = 1366*2;
+			break;
+		default:
+			screen_w = 720;
+			screen_h = 576;
+			GFXLINEPITCHSIZE = 720*2;
+			break;
+	}
+
+	pixel_width = 2;
+
+	/*df of 1900 support scale*/
+	GFXLINEPITCHSIZE=aImageWidth*2;
+
+	if(picture_color_mode == 6){
+		GFXLINEPITCHSIZE = GFXLINEPITCHSIZE*2;
+		pixel_width = 4;
+	}
+
+	printf("GFXLINEPITCHSIZE = %d, screen_h = %d\n",GFXLINEPITCHSIZE,screen_h);
+	/* clear screen */
+	//memset((void*)GFXBASEADDRESS, 0, GFXLINEPITCHSIZE * screen_h);
+
+	printf("pixel_width = %d\n",pixel_width);
+
+	disp_init(PixelOutputFormat, aImageWidth, aImageHeight, aOffsetLeft, aOffsetTop,apData,hdcp_status,colorspace_mode);
+
+	/*psrcbuf = (unsigned char*)pic_buf;
+	  pdstbuf = (unsigned char*)(GFXBASEADDRESS + (dst_y * GFXLINEPITCHSIZE) + dst_x * pixel_width);
+
+	  for(i = 0; i < pic_h; i++){
+	  memcpy(pdstbuf, psrcbuf, pic_w * pixel_width);
+	  psrcbuf += (pic_w*pixel_width);
+	  pdstbuf += GFXLINEPITCHSIZE;
+	  }*/
+
+	//	write_hd2sd_cmd(mode);
+#endif
+
+	return 0;
+}
+
+UInt8* UnzipIfReguired(UInt8* apSrcBuffer, UInt8* apDestinationBuffer)
+{
+	int Status;
+	if( ( *(apSrcBuffer + 0 ) == 0x1F) && ( *(apSrcBuffer + 1 ) == 0x8B )  )
+	{
+		printf("%slogo is in zip format\n%s", ColorYellow, ColorNormal);
+		//It is in zip format - run through unzip
+		unsigned long src=0;
+		unsigned long dst=0;
+		unsigned long src_len = ~0UL;
+		unsigned long dst_len = ~0UL;
+
+		src=src;
+		dst=dst;
+		src_len=src_len;
+		dst_len=dst_len;
+
+		Status =  gunzip( (void *) apDestinationBuffer, MAX_TEMP_SPLASH_BUFFER_SIZE , (void *) apSrcBuffer, &src_len);
+		if (Status != 0 )
+		{
+			return NULL;
+		}
+		printf("%sUnzip of logo is done successfully%s\n", ColorGreen, ColorNormal);
+	}
+	else
+	{
+		printf("%slogo is raw mode\n%s" , ColorYellow, ColorNormal);
+		//It is in raw mode. just cp the pointer.
+		apDestinationBuffer = apSrcBuffer;
+	}
+	return apDestinationBuffer;
+}
+#define GET_FROM_FLASH
+int do_cslogo(cmd_tbl_t *cmdtp, int flag, int argc, char *const argv[])
+{
+	unsigned int ImageWidth=0;
+	unsigned int ImageHeight=0;
+	unsigned int OffsetTop=0;
+	unsigned int OffsetLeft=0;
+	unsigned int PixelOutputFormat = 0;
+	unsigned int PictureColorMode = 0;
+	unsigned int DdrAddress = SPLASH_BUFFER;
+#ifdef GET_FROM_FLASH
+	unsigned int FlashAddress = 0;
+#endif
+	int Status=0;
+	int hdcp_status = 0 ;
+	int colorspace_mode = 0xff;
+
+	Status=Status;
+	ImageWidth=ImageWidth;
+	ImageHeight=ImageHeight;
+	OffsetTop=OffsetTop;
+	OffsetLeft=OffsetLeft;
+	PixelOutputFormat = PixelOutputFormat;
+	PictureColorMode = PictureColorMode;
+
+	printf("argc =%d\n",argc);
+	if( ! ( (argc == 7) ||  (argc == 8) || (argc == 9) || (argc == 10) ) ){
+		printf ("Usage:\n%s\n", cmdtp->usage);
+		return -1;
+	}
+
+	PixelOutputFormat = simple_strtoul(argv[1], NULL, 0);
+	PictureColorMode = simple_strtoul(argv[2], NULL, 0);
+	ImageWidth = simple_strtoul(argv[3], NULL, 0);
+	ImageHeight = simple_strtoul(argv[4], NULL, 0);
+	OffsetTop = simple_strtoul(argv[5], NULL, 0);
+	OffsetLeft = simple_strtoul(argv[6], NULL, 0);
+	if(((PixelOutputFormat<0)||(PixelOutputFormat>TVOUT_RGB_1366X768_60FPS))||((PictureColorMode<0)||(PictureColorMode>DF_GFX_XRGB8888))){
+		printf("Error input param!\n");
+		return -1;
+	}
+
+	
+	printf("PixelOutputFormat = %d, PictureColorMode = %d\n", (int)PixelOutputFormat ,(int) PictureColorMode );
+	printf("ImageWidth = %d ImageHeight = %d\n",(int) ImageWidth , (int)ImageHeight );
+	printf("OffsetTop = %d OffsetLeft = %d\n", (int)OffsetTop , (int)OffsetLeft );
+
+#ifdef GET_FROM_FLASH
+	if (argc == 8 ){
+		FlashAddress = simple_strtoul(argv[7], NULL, 16);
+		if(0xffffffff != FlashAddress){
+			Status = cnc_NandRead(FlashAddress,   TEMP_SPLASH_BUFFER,  MAX_TEMP_SPLASH_BUFFER_SIZE);
+			if (Status != 0 ){
+				printf("%sERROR: NAND read failed\n%s", ColorRed, ColorNormal );
+				return -1;
+			}
+		}
+	}
+	else{
+		//more preferred way
+		Status =  cnc_Read_MtdPartition(CONFIG_CNC_BOOTM_MTDID, "splash" , TEMP_SPLASH_BUFFER,  0xFFFFFFFF );
+		if (Status != 0 ){
+			printf("%sERROR: NAND read failed for partiotion name \"splash\"\n%s", ColorRed, ColorNormal );
+			return -1;
+		}
+	}
+#endif
+
+	if(argc == 9){
+		hdcp_status=simple_strtoul(argv[8], NULL, 0);
+		printf("hdcp_status = %d\n", hdcp_status);
+	}
+	if(argc == 10){
+		hdcp_status=simple_strtoul(argv[8], NULL, 0);
+		printf("hdcp_status = %d\n", hdcp_status);
+		colorspace_mode=simple_strtoul(argv[9], NULL, 0);
+		printf("colorspace_mode = %d\n",colorspace_mode);
+	}
+
+	if(!dcache_status()){
+		dcache_enable();
+	}
+	DdrAddress = (unsigned int) UnzipIfReguired( (unsigned char*) TEMP_SPLASH_BUFFER, (unsigned char*) SPLASH_BUFFER);
+	dcache_disable();
+
+	if (0 == DdrAddress ){
+		printf("%sUnable to process logo data\n%s" , ColorRed, ColorNormal);
+		return -1;
+	}
+
+	Status = DrawPicture(ImageWidth, ImageHeight, OffsetTop, OffsetLeft, PixelOutputFormat , PictureColorMode , (unsigned char*) DdrAddress ,hdcp_status, colorspace_mode);
+	return 0;
+}
+
+
+extern unsigned int gfxid;
+extern unsigned int UiStarted(void);
+extern void DFGfxSetAlpha(int GfxId, unsigned short DefaultAlpha, unsigned short ARGB1555Alpha0, unsigned short ARGB1555Alpha1);
+int do_csupgrade_logo(void)
+{
+	unsigned int DdrAddress = SPLASH_BUFFER;
+	int Status=0;
+
+	if(!UiStarted()){
+		printf("UI does not start!!!\n");
+		return -1;
+	}
+
+#ifdef GET_FROM_FLASH
+	Status =  cnc_Read_MtdPartition(CONFIG_CNC_BOOTM_MTDID, "update_splash" , TEMP_SPLASH_BUFFER,  0xFFFFFFFF );
+	if (Status != 0 ){
+		printf("%sERROR: NAND read failed for partiotion name \"update_splash\"\n%s", ColorRed, ColorNormal );
+		return -1;
+	}
+#endif
+	DFGfxSetAlpha(gfxid, 0, 0, 0);
+	if(!dcache_status()){
+		dcache_enable();
+	}
+	DdrAddress = (unsigned int) UnzipIfReguired( (unsigned char*) TEMP_SPLASH_BUFFER, (unsigned char*) SPLASH_BUFFER);
+	dcache_disable();
+
+	if (0 == DdrAddress ){
+		printf("%sUnable to process logo data\n%s" , ColorRed, ColorNormal);
+		return -1;
+	}
+
+	DFGfxSetAlpha(gfxid, 0xff, 0, 0);
+	printf("show upgrade splash logo\n");
+
+	return 0;
+}
+
+cnc_edid_t edid_storage;
+int tvoutmode_supported_res[TVOUT_MODE_MAX] = {0};
+int audmode_supported[CSAUD_HDMI_MAX] = {0};
+extern int do_call_external_proc(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+
+int do_edid(cmd_tbl_t *cmdtp, int flag, int argc, char *const argv[])
+{
+	int* ret_val = (int *)0xf000000;
+	char *hdmi_argv[5]={0};
+	int res = -1;
+	char* temp_char = NULL;
+	char* bootargs = NULL;
+	cnc_edid_t *edid = &edid_storage;
+
+	hdmi_argv[0]="call_external_proc";
+	hdmi_argv[1]="HDMI";
+	hdmi_argv[2]="0xff";
+
+	do_call_external_proc(NULL, 0, 4, hdmi_argv);
+	if(0xffffffff == *ret_val){
+		printf("HDMI not plug in or Read EDID info failed!\n");
+		return 1;
+	}
+
+	cnc_edid_init(edid);
+	memcpy(edid->edid_bin, (int *)0xf000004, ret_val[0]);
+	edid->edid_bin_valid = EDID_BIN_VALID;
+	edid->edid_bin_length = ret_val[0];
+
+	cnc_edid_parse(edid);
+	temp_char = getenv("PRINT_EDID");
+	if(NULL != temp_char){
+		printf("Original EDID:\n");
+		cnc_edid_print(edid);
+	}
+	res = cnc_edid_filter(edid, tvoutmode_supported_res, audmode_supported);
+	if(NULL != temp_char){
+		printf("Filtered EDID:\n");
+		cnc_edid_print(edid);
+	}
+	temp_char = NULL;
+	cnc_edid_clear_bin(edid);
+	printf("best res = %d\n", res);
+
+	if(-1 == res) {
+		printf("Unsupported format!\n");
+		return 1;
+	} else {
+		temp_char = NULL;
+		// set bootargs outputmode parameter
+		bootargs = getenv("bootargs");
+		//		printf("bootargs = %s\n", bootargs);
+		temp_char = strstr(bootargs,"outputmode=");
+		//		printf("temp_char = %s\n",temp_char);
+		if(NULL == temp_char){
+			temp_char = malloc(strlen(bootargs) + 20);
+			if(0 == temp_char){
+				printf("Not enough memory!\n");
+				return 1;
+			}
+			memcpy(temp_char, bootargs, strlen(bootargs));
+			sprintf(temp_char+strlen(bootargs)," outputmode=%d",res);
+			setenv("bootargs", temp_char);
+		}
+		else{
+			int num1 = 0;
+			int num2 = 0;
+			char* aaa = strchr(temp_char, '=');
+			char* bbb = strchr(temp_char, ' ');
+
+			num1 = aaa - bootargs;
+			//	printf("num1 = %d\n",num1);
+			//			printf("%s\n",aaa+1);
+			if(NULL == bbb){
+				temp_char = malloc(strlen(bootargs) + 20);
+				if(0 == temp_char){
+					printf("Not enough memory!\n");
+					return 1;
+				}
+				memcpy(temp_char, bootargs, num1+1);
+				sprintf(temp_char+num1+1,"%d",res);
+			}
+			else{
+				num2 = bbb - bootargs;
+				//	printf("num2 = %d\n",num2);
+				temp_char = malloc(strlen(bootargs) + 20);
+				if(0 == temp_char){
+					printf("Not enough memory!\n");
+					return 1;
+				}
+				strncpy(temp_char, bootargs, num1+1);
+				sprintf(temp_char+num1+1,"%d",res);
+				//				printf("strlen(temp_char) = %d\n",strlen(temp_char));
+				strncat(temp_char+strlen(temp_char), bbb,strlen(bbb));
+			}
+		}
+		setenv("bootargs", temp_char);
+		sprintf(temp_char, "%d", res);
+		setenv("OUTPUTMODE",temp_char);
+	}
+
+	return 0;
+}
+
+int do_aksv(cmd_tbl_t *cmdtp, int flag, int argc, char *const argv[])
+{
+	int* ret_val = (int *)0xf000000;
+	char *hdmi_argv[5]={0};
+
+	hdmi_argv[0]="call_external_proc";
+	hdmi_argv[1]="HDMI";
+	hdmi_argv[2]="0xfe";
+
+	do_call_external_proc(NULL, 0, 4, hdmi_argv);
+	if(0xffffffff == *ret_val){
+		printf("Read AKSV failed!\n");
+		return 1;
+	}
+
+	return 0;
+}
+
+
+int do_dump_tpi(cmd_tbl_t *cmdtp, int flag, int argc, char *const argv[])
+{
+	int* ret_val = (int *)0xf000000;
+	char *hdmi_argv[5]={0};
+
+	hdmi_argv[0]="call_external_proc";
+	hdmi_argv[1]="HDMI";
+	hdmi_argv[2]="0xfd";
+
+	do_call_external_proc(NULL, 0, 4, hdmi_argv);
+	if(0xffffffff == *ret_val){
+		printf("Dump TPI failed!\n");
+		return 1;
+	}
+
+	return 0;
+}
+
+U_BOOT_CMD(
+		logo,	10,	1,	do_cslogo,
+		"display logo picture on TV Screen",
+		"    - output mode(TVOUT_MODE): refer to the struct CSTVOUT_MODE in cstvout.h\n"
+		"    - color mode(DF_GFX_COLOR_FORMAT): refer to th struct CSOSD_COLOR_FORMAT in csosd.h\n"
+		"    - width(decimal): 	picture width\n"
+		"    - height(decimal): picture height\n"
+		"    - dstX(decimal): 	the top-left X coordinate of screen\n"
+		"    - dstY(decimal): 	the top-left Y coordinate of screen\n"
+		"    - Flash Address(hex): 	Flash address where splash is stored in flash\n"
+		"    - hdcp status: 	enable:1 disable:0(default)  \n"
+		"    - colorspace mode: override colorspace(0:RGB, 1:YUV444, 2:YUV422) \n"
+		"e.g.- logo output_mode color_mode 720 576 0 0 (optional Flash Address where image is stored, by default it will try to read from mtd partition name - splash)"
+		);
+
+U_BOOT_CMD(
+		edid,   1,  1,  do_edid,
+		"parse EDID to find the best resolution and set OUTPUTMODE.\n",
+		"parse EDID to find the best resolution and set OUTPUTMODE.\n"
+		);
+
+
+U_BOOT_CMD(
+		aksv,   1,  1,  do_aksv,
+		"output corresponding AKSV value.\n",
+		"output corresponding AKSV value.\n"
+		);
+
+U_BOOT_CMD(
+		dumptpi,   1,  1,  do_dump_tpi,
+		"output HDMI register value.\n",
+		"output HDMI register value.\n"
+		);
+
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_fpc.c u-boot-2011.06/common/cmd_fpc.c
--- u-boot-2011.06_original/common/cmd_fpc.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_fpc.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,164 @@
+/*
+ * Description:
+ * 		Fronpannel led show implementation, reference to
+ * 		kernel driver.
+ *
+ * Author: Celestial
+ */
+#include <common.h>
+#include <command.h>
+
+/*************************************************************
+ FPC_INIT
+ Description: Boot with a default sign on fpc led.
+ 	      For a better interaction.
+*************************************************************/
+
+/* Register Map */
+#define ORION_FPC_BASE          0x80172000
+
+#define FPC_INTS                (0x00  >> 1) /* Interrupt Status Register */
+#define FPC_INTM                (0x04  >> 1) /* Interrupt Mask Register */
+#define FPC_RC_CTL_L            (0x08  >> 1) /* Remote Control Register */
+#define FPC_RC_CMD_L            (0x100 >> 1) /* RC5 Command Register */
+#define FPC_NEC_CMD_L           (0x104 >> 1) /* NEC Command Register */
+#define FPC_LED_DATA_L          (0x200 >> 1) /* Led Display Data Register */
+#define FPC_LED_CNTL_L          (0x204 >> 1) /* Led Display Control Register */
+#define FPC_KSCAN_DATA_L        (0x300 >> 1) /* Key Scan Data Register */
+#define FPC_KSCAN_CNTL_L        (0x304 >> 1) /* Key Scan Control Register */
+#define FPC_ARBCNTL_L           (0x308 >> 1) /* Led & Key Scan Arbiter Control Register */
+#define FPC_RC_CTL_H            (0x0a  >> 1) /* Remote Control Register */
+#define FPC_RC_CMD_H            (0x102 >> 1) /* RC5 Command Register */
+#define FPC_NEC_CMD_H           (0x106 >> 1) /* NEC Command Register */
+#define FPC_LED_DATA_H          (0x202 >> 1) /* Led Display Data Register */
+#define FPC_LED_CNTL_H          (0x206 >> 1) /* Led Display Control Register */
+#define FPC_KSCAN_DATA_H        (0x302 >> 1) /* Key Scan Data Register */
+#define FPC_KSCAN_CNTL_H        (0x306 >> 1) /* Key Scan Control Register */
+#define FPC_ARBCNTL_H           (0x30a >> 1) /* Led & Key Scan Arbiter Control Register */
+
+
+#define fpc_writew(v,a)         do { *((volatile unsigned short *)ORION_FPC_BASE + (a)) = v; }while(0)
+#define fpc_readw(a)            *((volatile unsigned short  *)ORION_FPC_BASE + (a))
+
+static unsigned char num_tab[] = {
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, /* 0x00 */
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, /* 0x10 */
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	/* */ /*!*/ /*"*/ /*#*/ /*$*/ /*%*/ /*&*/ /*'*/
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, /* 0x20 */
+	/*(*/ /*)*/ /***/ /*+*/ /*,*/  /*-*/ /*.*/ /*/*/
+	0x63, 0x0F, 0xff, 0xff, 0xff, 0xfd, 0xFE, 0xff,
+	/*0*/ /*1*/ /*2*/ /*3*/ /*4*/ /*5*/ /*6*/ /*7*/
+	0x03, 0x9f, 0x25, 0x0d, 0x99, 0x49, 0x41, 0x1f, /* 0x30 */
+	/*8*/ /*9*/ /* */ /* */ /* */ /* */ /* */ /* */
+	0x01, 0x09, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	/* */ /*A*/ /*B*/ /*C*/ /*D*/ /*E*/ /*F*/ /*G*/
+	0xff, 0x11, 0x01, 0x63, 0x85, 0x61, 0x71, 0x09, /* 0x40 */
+	/*H*/ /*I*/ /*J*/ /*K*/ /*L*/ /*M*/ /*N*/ /*O*/
+	0x91, 0x9f, 0x87, 0xff, 0xe3, 0xff, 0x13, 0x03,
+	/*P*/ /*Q*/ /*R*/ /*S*/ /*T*/ /*U*/ /*V*/ /*W*/
+	0x31, 0x19, 0xF5, 0x49, 0xE1, 0x83, 0xff, 0xff, /* 0x50 */
+	/*X*/ /*Y*/ /*Z*/ /*[*/ /*\*/ /*]*/ /*^*/ /*_*/
+	0xff, 0x89, 0xff, 0x63, 0xff, 0x0F, 0xff, 0xEF,
+	/*`*/ /*a*/ /*b*/ /*c*/ /*d*/ /*e*/ /*f*/ /*g*/
+	0xff, 0x11, 0xC1, 0xE5, 0x85, 0x61, 0x71, 0x09, /* 0x60 */
+	/*h*/ /*i*/  /*j*/ /*k*/ /*l*/ /*m*/ /*n*/ /*o*/
+	0xD1, 0x9f, 0x87, 0xff, 0xe3, 0xff, 0xD5, 0xC5,
+	/*p*/ /*q*/ /*r*/ /*s*/ /*t*/ /*u*/ /*v*/ /*w*/
+	0x31, 0x19, 0xF5, 0x49, 0xE1, 0xC7, 0xff, 0xff, /* 0x70 */
+	/*x*/ /*y*/ /*z*/ /*{*/ /*|*/ /*}*/ /*~*/ /* */
+	0xff, 0x89, 0xff, 0xff, 0x9F, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, /* 0x80 */
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, /* 0x90 */
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, /* 0xa0 */
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, /* 0xb0 */
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, /* 0xc0 */
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, /* 0xd0 */
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, /* 0xe0 */
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, /* 0xf0 */
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
+};
+
+
+void fpc_led_enable(int cmd)
+{
+	fpc_writew(0x8000, FPC_LED_CNTL_H);
+	fpc_writew(0 != cmd ? 0x1000 : 0x0000, FPC_LED_CNTL_L);
+}
+
+void fpc_led_disp(int arg)
+{
+	fpc_writew((arg >> 16) & 0xffff, FPC_LED_DATA_H);
+	fpc_writew(arg & 0xffff, FPC_LED_DATA_L);
+}
+
+void fpc_init_show(const char *string)
+{
+	int i, val;
+	char  str[5] = { 0 };
+
+	sprintf(str,"%-4s", string);
+
+	for (val = 0, i = 0; i<4 ; i++)
+		val |= num_tab[(int)str[i]] << (8 * i);
+
+	fpc_led_disp(val);
+	fpc_led_enable(1);
+}
+
+#define GPIO_PINMUX() do {}while(0)
+
+int do_fpc_led (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
+{
+	 GPIO_PINMUX();
+	 fpc_init_show(argv[1]);
+
+	 return 0;
+}
+
+U_BOOT_CMD(
+	fpcd,	CONFIG_SYS_MAXARGS/*5*/,	1,	do_fpc_led,
+	"Display data on frontpanel led",
+	"<data>"
+	);
+
+int do_fpcraw (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
+{
+	u32 val;
+
+	val = simple_strtoul(argv[1], NULL, 16);
+
+	GPIO_PINMUX();
+
+	fpc_led_disp(val);
+	fpc_led_enable(1);
+
+	return 0;
+}
+int do_enagpio2(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
+{
+	fpc_writew(0x4000, FPC_LED_CNTL_H);
+	fpc_writew(0x0000, FPC_LED_CNTL_L);
+	return 0;
+}
+
+U_BOOT_CMD(
+	fpcraw,	CONFIG_SYS_MAXARGS/*5*/,	1,	do_fpcraw,
+	"Display raw data on frontpanel led",
+	"<data>"
+	);
+
+U_BOOT_CMD(
+	disled,	CONFIG_SYS_MAXARGS/*5*/,	1,	do_enagpio2,
+	"Disable LED display and enable GPIO2",
+	""
+	);
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_gpio.c u-boot-2011.06/common/cmd_gpio.c
--- u-boot-2011.06_original/common/cmd_gpio.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/common/cmd_gpio.c	2014-07-29 17:28:38.819972000 +0800
@@ -1,89 +1,78 @@
 /*
- * Control GPIO pins on the fly
+ * Basic GPIO functions
  *
- * Copyright (c) 2008-2011 Analog Devices Inc.
+ * Copyright (c) 2008 Celestial Semiconductor
+ *
+ * This package is free software;  you can redistribute it and/or
+ * modify it under the terms of the license found in the file
+ * named COPYING that should have accompanied this file.
+ *
+ * THIS PACKAGE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
+ * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
+ *
+ * Author: Tu BaoZhao bz.tu@celestialsemi.com, Celestial Semiconductor
+ *
+ * Copyright (c) 2007 Celestial Semiconductor
  *
- * Licensed under the GPL-2 or later.
  */
 
 #include <common.h>
 #include <command.h>
 
-#include <asm/gpio.h>
+extern void 		 gpio_hw_set_direct(int gpio_id, int data);
+extern unsigned int  gpio_hw_read(int gpio_id);
+extern void          gpio_hw_write(int gpio_id, int data);
 
-#ifndef name_to_gpio
-#define name_to_gpio(name) simple_strtoul(name, NULL, 10)
-#endif
-
-enum gpio_cmd {
-	GPIO_INPUT,
-	GPIO_SET,
-	GPIO_CLEAR,
-	GPIO_TOGGLE,
-};
 
-static int do_gpio(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+int do_gpio(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
 {
-	int gpio;
-	enum gpio_cmd sub_cmd;
-	ulong value;
-	const char *str_cmd, *str_gpio;
-
-#ifdef gpio_status
-	if (argc == 2 && !strcmp(argv[1], "status")) {
-		gpio_status();
-		return 0;
-	}
-#endif
+	int gpio_id;
+	unsigned short data;
 
-	if (argc != 3)
- show_usage:
-		return cmd_usage(cmdtp);
-	str_cmd = argv[1];
-	str_gpio = argv[2];
-
-	/* parse the behavior */
-	switch (*str_cmd) {
-		case 'i': sub_cmd = GPIO_INPUT;  break;
-		case 's': sub_cmd = GPIO_SET;    break;
-		case 'c': sub_cmd = GPIO_CLEAR;  break;
-		case 't': sub_cmd = GPIO_TOGGLE; break;
-		default:  goto show_usage;
+	if (argc < 3 || argc > 4) {
+		printf("Usage: %s\n", cmdtp->help);
+		return -1;
 	}
 
-	/* turn the gpio name into a gpio number */
-	gpio = name_to_gpio(str_gpio);
-	if (gpio < 0)
-		goto show_usage;
-
-	/* grab the pin before we tweak it */
-	if (gpio_request(gpio, "cmd_gpio")) {
-		printf("gpio: requesting pin %u failed\n", gpio);
+	gpio_id = simple_strtoul(argv[2], NULL, 0);
+	if (gpio_id < 0 || gpio_id >41) {
+		printf("%s: invalid parameters! at line: %d\n",
+			__FUNCTION__, __LINE__);
 		return -1;
 	}
 
-	/* finally, let's do it: set direction and exec command */
-	if (sub_cmd == GPIO_INPUT) {
-		gpio_direction_input(gpio);
-		value = gpio_get_value(gpio);
-	} else {
-		switch (sub_cmd) {
-			case GPIO_SET:    value = 1; break;
-			case GPIO_CLEAR:  value = 0; break;
-			case GPIO_TOGGLE: value = !gpio_get_value(gpio); break;
-			default:          goto show_usage;
+	if (strcmp(argv[1], "read") == 0) {
+		if (argc > 3) {
+			printf("Usage: %s\n", cmdtp->help);
+			return -1;
 		}
-		gpio_direction_output(gpio, value);
-	}
-	printf("gpio: pin %s (gpio %i) value is %lu\n",
-		str_gpio, gpio, value);
 
-	gpio_free(gpio);
+		gpio_hw_set_direct(gpio_id, 0);
+		data = gpio_hw_read(gpio_id);
+		printf("gpio[%d] = %u\n", gpio_id, data);
+	} else if (strcmp(argv[1], "write") == 0) {
+		if (argc < 4) {
+			printf("Usage: %s\n", cmdtp->help);
+			return -1;
+		}
 
-	return value;
+		data = simple_strtoul(argv[3], NULL, 0);
+		gpio_hw_set_direct(gpio_id, 1);
+		gpio_hw_write(gpio_id, data);
+		printf("Write ok!\n");
+	} else {
+		printf("Usage: %s\n", cmdtp->help);
+		return -1;
+	}
+
+	return 0;
 }
 
-U_BOOT_CMD(gpio, 3, 0, do_gpio,
-	"input/set/clear/toggle gpio pins",
-	"<input|set|clear|toggle> <pin>\n"
-	"    - input/set/clear/toggle the specified pin");
+U_BOOT_CMD(
+	gpio,	CONFIG_SYS_MAXARGS/*5*/,	1,	do_gpio,
+	"gpio    - gpio read/write bit\n",
+	"\ngpio <read>  <gpio_id>\n"
+	"gpio <write> <gpio_id> <data>\n"
+	);
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_gpio.c_2011.06 u-boot-2011.06/common/cmd_gpio.c_2011.06
--- u-boot-2011.06_original/common/cmd_gpio.c_2011.06	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_gpio.c_2011.06	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,89 @@
+/*
+ * Control GPIO pins on the fly
+ *
+ * Copyright (c) 2008-2011 Analog Devices Inc.
+ *
+ * Licensed under the GPL-2 or later.
+ */
+
+#include <common.h>
+#include <command.h>
+
+#include <asm/gpio.h>
+
+#ifndef name_to_gpio
+#define name_to_gpio(name) simple_strtoul(name, NULL, 10)
+#endif
+
+enum gpio_cmd {
+	GPIO_INPUT,
+	GPIO_SET,
+	GPIO_CLEAR,
+	GPIO_TOGGLE,
+};
+
+static int do_gpio(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	int gpio;
+	enum gpio_cmd sub_cmd;
+	ulong value;
+	const char *str_cmd, *str_gpio;
+
+#ifdef gpio_status
+	if (argc == 2 && !strcmp(argv[1], "status")) {
+		gpio_status();
+		return 0;
+	}
+#endif
+
+	if (argc != 3)
+ show_usage:
+		return cmd_usage(cmdtp);
+	str_cmd = argv[1];
+	str_gpio = argv[2];
+
+	/* parse the behavior */
+	switch (*str_cmd) {
+		case 'i': sub_cmd = GPIO_INPUT;  break;
+		case 's': sub_cmd = GPIO_SET;    break;
+		case 'c': sub_cmd = GPIO_CLEAR;  break;
+		case 't': sub_cmd = GPIO_TOGGLE; break;
+		default:  goto show_usage;
+	}
+
+	/* turn the gpio name into a gpio number */
+	gpio = name_to_gpio(str_gpio);
+	if (gpio < 0)
+		goto show_usage;
+
+	/* grab the pin before we tweak it */
+	if (gpio_request(gpio, "cmd_gpio")) {
+		printf("gpio: requesting pin %u failed\n", gpio);
+		return -1;
+	}
+
+	/* finally, let's do it: set direction and exec command */
+	if (sub_cmd == GPIO_INPUT) {
+		gpio_direction_input(gpio);
+		value = gpio_get_value(gpio);
+	} else {
+		switch (sub_cmd) {
+			case GPIO_SET:    value = 1; break;
+			case GPIO_CLEAR:  value = 0; break;
+			case GPIO_TOGGLE: value = !gpio_get_value(gpio); break;
+			default:          goto show_usage;
+		}
+		gpio_direction_output(gpio, value);
+	}
+	printf("gpio: pin %s (gpio %i) value is %lu\n",
+		str_gpio, gpio, value);
+
+	gpio_free(gpio);
+
+	return value;
+}
+
+U_BOOT_CMD(gpio, 3, 0, do_gpio,
+	"input/set/clear/toggle gpio pins",
+	"<input|set|clear|toggle> <pin>\n"
+	"    - input/set/clear/toggle the specified pin");
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_gpt.c u-boot-2011.06/common/cmd_gpt.c
